#ifndef __DILLOCFG_GTK_H__
#define __DILLOCFG_GTK_H__

#include <gtk/gtk.h>

#include "../config.h"
#include "dillocfg_option.h"

#define WIDTH  640
#define HEIGHT 370
#define USER_CFG ".dillo/dillorc"
#define USER_COOKIE_CFG ".dillo/cookiesrc"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef DISABLE_TABS
   typedef struct {
      Option *tab_bar_homogeneous;
      Option *tab_bar_scroller;
      Option *tab_bar_show_fullscreen;
      Option *tab_bar_show_single_tab;
      Option *tab_instead_of_window;
      Option *tab_load_in_background;
      Option *tab_close_middle_click;
      Option *compress_vowels;
      Option *compress_common_prefixes;
      Option *tab_title_compress;
   } DillocfgTab;
#endif

   typedef struct {
      Option *w3c_plus_heuristics;
      Option *use_dicache;
      Option *focus_location_on_new;
      Option *enterpress_forces_submit;
      Option *limit_text_width;
      Option *generate_submit;
      Option *search_url;
      Option *search_charset;
      Option *accept_language;
      Option *show_msg;
      Option *show_extra_warnings;
   } DillocfgOther;

   typedef struct {
      Option *geometry;
      Option *panel_size;
      Option *show_back;
      Option *show_bookmarks;
      Option *show_clear_url;
      Option *show_forw;
      Option *show_home;
      Option *show_menubar;
      Option *show_popup_navigation;
      Option *show_progress_box;
      Option *show_reload;
      Option *show_save;
      Option *show_stop;
      Option *show_tooltip;
      Option *show_url;
      Option *show_search;
      Option *small_icons;
      Option *fullwindow_start;
      Option *transient_dialogs;
      Option *popup_dialogs;
   } DillocfgInterface;

   typedef struct {
      Option *font_sizes;
      Option *font_factor;
      Option *vw_fontname;
      Option *fw_fontname;
      Option *vw_aafontname;
      Option *fw_aafontname;
      Option *use_oblique;
      Option *limit_font_decoration;
   } DillocfgFont;

   typedef struct {
      Option *force_my_colors;
      Option *contrast_visited_color;
      Option *allow_white_bg;
      Option *link_color;
      Option *bg_color;
      Option *visited_color;
      Option *text_color;
   } DillocfgColor;

   typedef struct {
      Option *user_agent;
      Option *home;
      Option *start_page;
      Option *http_proxy;
      Option *http_proxyuser;
      Option *no_proxy;
      Option *send_referer;
   } DillocfgNetwork;

   typedef struct {
      Option    *cookie_default;
   } DillocfgCookie;

   typedef struct {
      GtkWidget         *notebook;
      GList             *list;
      DillocfgInterface *interface;
      DillocfgFont      *font;
      DillocfgColor     *color;
      DillocfgNetwork   *network;
#ifndef DISABLE_TABS
      DillocfgTab       *tab;
#endif
      DillocfgCookie    *cookie;
      DillocfgOther     *other;
   } DillocfgWin;

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __DILLOCFG_GTK_H__ */

/* vim: set ts=3 sw=3 sts=3 expandtab:*/
