#ifndef __DILLOCFG_GTK_OPTION_H__
#define __DILLOCFG_GTK_OPTION_H__

#include <stdio.h>
#include <gtk/gtk.h>

#include "../config.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

   typedef enum {
      CHECK_OPTION = 0,
      ENTRY_OPTION,
      COMBO_OPTION,
      FONT_OPTION,
      SELECT_OPTION,
      COLOR_OPTION,
      SPIN_OPTION,
      GEOMETRY_OPTION,
      COOKIE
   } OptionType;

   typedef struct {
      guint     token;
      void  (*init)();
      void   (*set)();
      gchar *(*get)();
      void  (*free)();
   } OptionBase;

   typedef struct {
      OptionBase base;
   } Option;

   typedef struct {
      gfloat lower;
      gfloat upper;
      gfloat increment;
      guint  digits;
   } OptionAdjustment_t;

   Option *Option_new(guint token, GList **list, GtkWidget *table, gint x, gint y);
   void    Option_init(Option *o, gboolean use_default);
   void    Option_set(Option *o, gchar *value);
   gchar  *Option_get(Option *o, FILE *fp);
   void    Option_free(Option *o, GList **list);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __DILLOCFG_GTK_OPTION_H__ */

/* vim: set ts=3 sw=3 sts=3 expandtab:*/
